package me.savvy.rixa.guild.management;

import lombok.Getter;
import me.savvy.rixa.guild.RixaGuild;
import net.dv8tion.jda.core.entities.Guild;

import java.util.HashMap;
import java.util.Map;

public class Guilds {

    @Getter
    private static Map<String, RixaGuild> guilds = new HashMap<>();

    public static void addGuild(RixaGuild guild) {
        if (check(guild.getGuild())) return;
        guilds.put(guild.getGuild().getId(), guild);
    }

    public static RixaGuild getGuild(Guild guild) {
        if (guild == null) return null;
        if (!check(guild)) {
            addGuild(new RixaGuild(guild));
        }
        return guilds.get(guild.getId());
    }

    public static void removeGuild(RixaGuild guild) {
        if (!check(guild.getGuild())) return;
        guilds.remove(guild.getGuild().getId());
    }

    private static boolean check(Guild guild) {
        if (guild == null) return false;
        return guilds.containsKey(guild.getId());
    }
}
